#include <stdio.h>
#include <Windows.h>

#include "komunikacia.h"

static HANDLE hComm;
static int sbot_is_open = 0;


void error_message(WCHAR *msg, WCHAR *title)
{
		WCHAR errmsg[256];
		wsprintf(errmsg, L"%s, error=%d\n", msg, GetLastError());
		MessageBox(0, errmsg, title, MB_OK);
}

int sbot_write(char *msg)
{
	DWORD written;

	if (!WriteFile(hComm, msg, strlen(msg), &written, 0))
	{
	    error_message(L"WriteFile did not succeed", L"error getting sbot status");
  		sbot_close();
		return 0;
	}
	//FlushFileBuffers(hComm);
	return 1;
}

// ovor komunikan port
int sbot_open(WCHAR *communication_port)
{
	hComm = CreateFile( communication_port, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);

	if (hComm == INVALID_HANDLE_VALUE) //error openning port
	{
		error_message(L"CreateFile returned invalid handle", L"Error opening sbot");
		return 0;
	}

	sbot_is_open = 1;	
	return 1;
}

void sbot_close()
{
    CloseHandle(hComm);
	sbot_is_open = 0;
}

char *sbot_read_line()
{
	static char packet[100];
	int pi = 0;
	DWORD bytesread;

	do {

	    if (!ReadFile(hComm, packet + pi, 1, &bytesread, 0))
		{
		  error_message(L"ReadFile did not succeed", L"reading line from sbot");
		  CloseHandle(hComm);
		  return "-1 -1";
  	    }
		pi++;
		if (pi == 99) break; 

	} while (packet[pi-1] != '\n');
	packet[pi] = 0;

	return packet;
}

/*
** JEDNOTLIV PRKAZY
** musia korepondova s programom v SBOTovi
*/

sbot_status *sbot_get_status()
{
    if (!sbot_write("s\n")) return 0;

	char *packet = sbot_read_line();

    sbot_status *status = new sbot_status;
	sscanf_s(packet, "%d %d %d %d %d %d\n", &(status->s1), &(status->s2), &(status->s3), &(status->s4), &(status->s5), &(status->s6));

	return status;
}

void sbot_forward()
{
	sbot_write("f\n");
}

void sbot_left()
{
	sbot_write("l\n");
}

void sbot_right()
{
	sbot_write("r\n");
}

void sbot_back()
{
	sbot_write("b\n");
}

void sbot_rotate()
{
	sbot_write("o\n");
}

void sbot_stop()
{
	sbot_write("p\n");
}

void sbot_skuska()
{
	sbot_write("j\n");
}

void sbot_hello()
{
	sbot_write("a\n");
}

